var __extends = this.__extends || function (d, b) {
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var CodeCompass;
(function (CodeCompass) {
    (function (Drawings) {
        (function (Raphael2D) {
            var Canvas = (function () {
                function Canvas(element, width, height) {
                    if (typeof width === "undefined") { width = 1000; }
                    if (typeof height === "undefined") { height = width * 9 / 16; }
                    this.width = width;
                    this.height = height;
                    Ensure.defined(element, "element: string (Canvas)").defined(width, "width: number (Canvas)").defined(height, "height: number (Canvas)");
                    this._id = element;
                    this._paper = Raphael(element, width, height);
                }
                Object.defineProperty(Canvas.prototype, "id", {
                    get: function () {
                        return this._id;
                    },
                    set: function (value) {
                        this._id = value;
                        $("#" + value).attr("id", value);
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Canvas.prototype, "className", {
                    get: function () {
                        return this._className;
                    },
                    set: function (value) {
                        this._className = value;
                        $("." + value).attr("class", value);
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Canvas.prototype, "paper", {
                    get: function () {
                        return this._paper;
                    },
                    enumerable: true,
                    configurable: true
                });
                return Canvas;
            })();
            Raphael2D.Canvas = Canvas;            
            var Stroke = (function () {
                function Stroke(element) {
                    this.color = Drawings.Colors.Black;
                    this.miterlimit = 0;
                    this.size = 1;
                    this.linecap = Drawings.LineCap.butt;
                    this.linejoin = Drawings.LineJoin.bevel;
                    this.element = element;
                }
                Object.defineProperty(Stroke.prototype, "element", {
                    get: function () {
                        return this._element;
                    },
                    set: function (value) {
                        Ensure.defined(value, "element: RaphaelElement (Stroke)");
                        this._element = value;
                        this.refresh();
                    },
                    enumerable: true,
                    configurable: true
                });
                Stroke.prototype.refresh = function () {
                    if(Ensure.hasValue(this.element)) {
                        this.element.attr({
                            "stroke": Ensure.hasValue(this.color) ? this.color.toCSS() : "black",
                            "stroke-width": this.size,
                            "stroke-linecap": this.linecap,
                            "stroke-linejoin": this.linejoin,
                            "stroke-miterlimit": this.miterlimit
                        });
                    }
                };
                Object.defineProperty(Stroke.prototype, "color", {
                    get: function () {
                        return this._color;
                    },
                    set: function (value) {
                        if(Ensure.hasValue(value)) {
                            this._color = value;
                            if(Ensure.hasValue(this.element)) {
                                this.element.attr({
                                    "stroke": this.color.toCSS()
                                });
                            }
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Stroke.prototype, "size", {
                    get: function () {
                        return this._size;
                    },
                    set: function (value) {
                        if(Ensure.hasValue(value)) {
                            this._size = value;
                            if(Ensure.hasValue(this.element)) {
                                this.element.attr({
                                    "stroke-width": this.size
                                });
                            }
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Stroke.prototype, "linecap", {
                    get: function () {
                        return this._linecap;
                    },
                    set: function (value) {
                        if(Ensure.hasValue(value)) {
                            this._linecap = value;
                            if(Ensure.hasValue(this.element)) {
                                this.element.attr({
                                    "stroke-linecap": this.linecap
                                });
                            }
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Stroke.prototype, "linejoin", {
                    get: function () {
                        return this._linejoin;
                    },
                    set: function (value) {
                        if(Ensure.hasValue(value)) {
                            this._linejoin = value;
                            if(Ensure.hasValue(this.element)) {
                                this.element.attr({
                                    "stroke-linejoin": this.linejoin
                                });
                            }
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(Stroke.prototype, "miterlimit", {
                    get: function () {
                        return this._miterlimit;
                    },
                    set: function (value) {
                        if(Ensure.hasValue(value)) {
                            this._miterlimit = value;
                            if(Ensure.hasValue(this.element)) {
                                this.element.attr({
                                    "stroke-miterlimit": this.miterlimit
                                });
                            }
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                return Stroke;
            })();
            Raphael2D.Stroke = Stroke;            
        })(Drawings.Raphael2D || (Drawings.Raphael2D = {}));
        var Raphael2D = Drawings.Raphael2D;
    })(CodeCompass.Drawings || (CodeCompass.Drawings = {}));
    var Drawings = CodeCompass.Drawings;
})(CodeCompass || (CodeCompass = {}));
var CodeCompass;
(function (CodeCompass) {
    (function (Drawings) {
        (function (Raphael2D) {
            (function (Utilities) {
                (function (Point2D) {
                    function getPath() {
                        var points = [];
                        for (var _i = 0; _i < (arguments.length - 0); _i++) {
                            points[_i] = arguments[_i + 0];
                        }
                        return getPathFromArray(points);
                    }
                    Point2D.getPath = getPath;
                    function getPathFromArray(points) {
                        var result = "M";
                        return Let(result).be(function (value) {
                            var output = [];
                            for(var index in points) {
                                output.push(points[index].x + " " + points[index].y);
                            }
                            value += output.join("L");
                            return value;
                        }).value;
                    }
                    Point2D.getPathFromArray = getPathFromArray;
                    function arrange(container, points) {
                        Ensure.defined(container).defined(points);
                        var list = Enumerable.From(points).Select(function (point, index) {
                            var absolute = true;
                            Safe(point).tryGet("isAbsolute", function (value) {
                                absolute = value;
                            });
                            var result = {
                                x: absolute ? point.x : point.x * container.width,
                                y: absolute ? point.y : point.y * container.height
                            };
                            Safe(point).tryGet("horizontalAlign", function (value) {
                                switch(value) {
                                    case Drawings.HorizontalAlign.left:
                                        result.x = point.x * container.width;
                                        break;
                                    case Drawings.HorizontalAlign.center:
                                        result.x = absolute ? point.x + container.width / 2.0 : (0.5 - point.x) * container.width;
                                        break;
                                    case Drawings.HorizontalAlign.right:
                                        result.x = absolute ? point.x + container.width : (1.0 - point.x) * container.width;
                                        break;
                                }
                            }).tryGet("verticalAlign", function (value) {
                                switch(value) {
                                    case Drawings.VerticalAlign.top:
                                        result.y = point.y * container.height;
                                        break;
                                    case Drawings.VerticalAlign.center:
                                        result.y = absolute ? point.y + container.height / 2.0 : (0.5 - point.y) * container.height;
                                        break;
                                    case Drawings.VerticalAlign.bottom:
                                        result.y = absolute ? point.y + container.height : (1.0 - point.y) * container.height;
                                        break;
                                }
                            });
                            return new CodeCompass.Drawings.Point2D(result.x, result.y);
                        }).ToArray();
                        return list;
                    }
                    Point2D.arrange = arrange;
                    function toSize(value) {
                        return {
                            width: value.x,
                            height: value.y
                        };
                    }
                    Point2D.toSize = toSize;
                })(Utilities.Point2D || (Utilities.Point2D = {}));
                var Point2D = Utilities.Point2D;
                (function (Size) {
                    function toPoint(value) {
                        return CodeCompass.Drawings.Point2D.create(value.width, value.height);
                    }
                    Size.toPoint = toPoint;
                    function arrange(container, sizes) {
                        var list = Enumerable.From(sizes).Select(function (size, index) {
                            var result;
                            if(Safe(size).has("isAbsolute")) {
                                result = new CodeCompass.Drawings.Size(container.width * size.width, container.height * size.height);
                            } else {
                                result = new CodeCompass.Drawings.Size(size.width, size.height);
                            }
                            return result;
                        }).ToArray();
                        return list;
                    }
                    Size.arrange = arrange;
                })(Utilities.Size || (Utilities.Size = {}));
                var Size = Utilities.Size;
            })(Raphael2D.Utilities || (Raphael2D.Utilities = {}));
            var Utilities = Raphael2D.Utilities;
        })(Drawings.Raphael2D || (Drawings.Raphael2D = {}));
        var Raphael2D = Drawings.Raphael2D;
    })(CodeCompass.Drawings || (CodeCompass.Drawings = {}));
    var Drawings = CodeCompass.Drawings;
})(CodeCompass || (CodeCompass = {}));
var CodeCompass;
(function (CodeCompass) {
    (function (Drawings) {
        (function (Raphael2D) {
            (function (Primitives) {
                var GraphicalObject = (function () {
                    function GraphicalObject(canvas, location, size) {
                        this.canvas = canvas;
                        this._isDisposed = false;
                        this._location = location;
                        this._visible = true;
                        this._size = size;
                    }
                    Object.defineProperty(GraphicalObject.prototype, "isDisposed", {
                        get: function () {
                            return this._isDisposed;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(GraphicalObject.prototype, "size", {
                        get: function () {
                            return this._size;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._size = value;
                            if(Ensure.isDefined(this._element)) {
                                this._element.attr({
                                    "width": value.width,
                                    "height": value.height,
                                    "rx": value.width / 2.0,
                                    "ry": value.height / 2.0
                                });
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(GraphicalObject.prototype, "visible", {
                        get: function () {
                            return this._visible;
                        },
                        set: function (value) {
                            Ensure.defined(value, "value: bool (GraphicalObject)");
                            this._visible = value;
                            if(value) {
                                this.element.show();
                            } else {
                                this.element.hide();
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(GraphicalObject.prototype, "element", {
                        get: function () {
                            return this._element;
                        },
                        set: function (value) {
                            this._element = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(GraphicalObject.prototype, "location", {
                        get: function () {
                            return this._location;
                        },
                        set: function (value) {
                            Ensure.defined(value, "value: IPoint2D (GraphicalObject)");
                            this._location = value;
                            this._element.attr({
                                "x": value.x,
                                "y": value.y,
                                "cx": value.x,
                                "cy": value.y
                            });
                        },
                        enumerable: true,
                        configurable: true
                    });
                    GraphicalObject.prototype.dispose = function () {
                        if(!this.isDisposed && Ensure.isDefined(this.element)) {
                            this.element.remove();
                            this._isDisposed = true;
                        }
                        return this;
                    };
                    return GraphicalObject;
                })();
                Primitives.GraphicalObject = GraphicalObject;                
                var Shape = (function (_super) {
                    __extends(Shape, _super);
                    function Shape(canvas, location, size) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = Drawings.Size.Zero; }
                                        _super.call(this, canvas, location, size);
                        Ensure.defined(canvas, "canvas: Canvas (Shape)").defined(location, "location: IPoint (Shape)").defined(size, "size: ISize (Shape)");
                        this._border = null;
                        this.fill = Drawings.Colors.Blue;
                    }
                    Object.defineProperty(Shape.prototype, "fill", {
                        get: function () {
                            return this._fill;
                        },
                        set: function (value) {
                            if(Ensure.hasValue(value)) {
                                this._fill = value;
                                if(Ensure.hasValue(this.element)) {
                                    this.element.attr({
                                        fill: value.toCSS()
                                    });
                                }
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Shape.prototype, "border", {
                        get: function () {
                            return this._border;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Shape.prototype, "element", {
                        get: function () {
                            return this._element;
                        },
                        set: function (value) {
                            Ensure.defined(value, "value: RaphaelElement (Shape)");
                            this._element = value;
                            if(!Ensure.hasValue(this.border)) {
                                this._border = new Raphael2D.Stroke(value);
                            } else {
                                this.border.element = value;
                            }
                            this.element.attr({
                                fill: this.fill.toCSS()
                            });
                        },
                        enumerable: true,
                        configurable: true
                    });
                    return Shape;
                })(GraphicalObject);
                Primitives.Shape = Shape;                
                var Rectange = (function (_super) {
                    __extends(Rectange, _super);
                    function Rectange(canvas, location, size) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = Drawings.Size.Zero; }
                                        _super.call(this, canvas, location, size);
                        this.init();
                    }
                    Rectange.prototype.init = function () {
                        this.element = (this.canvas).paper.rect(this.location.x, this.location.y, this.size.width, this.size.height);
                    };
                    return Rectange;
                })(Shape);
                Primitives.Rectange = Rectange;                
                var Ellipse = (function (_super) {
                    __extends(Ellipse, _super);
                    function Ellipse(canvas, location, size) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = Drawings.Size.Zero; }
                                        _super.call(this, canvas, location, size);
                        this.init();
                    }
                    Ellipse.prototype.init = function () {
                        this.element = (this.canvas).paper.ellipse(this.location.x, this.location.y, this.size.width / 2.0, this.size.height / 2.0);
                    };
                    return Ellipse;
                })(Shape);
                Primitives.Ellipse = Ellipse;                
                var Polygon = (function (_super) {
                    __extends(Polygon, _super);
                    function Polygon(canvas, points, closed, location, size) {
                        if (typeof closed === "undefined") { closed = true; }
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = Drawings.Size.Zero; }
                                        _super.call(this, canvas, location, size);
                        this.points = points;
                        this._closed = false;
                        this._closed = closed;
                        this.init();
                    }
                    Object.defineProperty(Polygon.prototype, "isClosed", {
                        get: function () {
                            return this._closed;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Polygon.prototype, "size", {
                        get: function () {
                            return this._size;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._size = value;
                            if(Ensure.isDefined(this.element)) {
                                this.init();
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Polygon.prototype, "location", {
                        get: function () {
                            return this._location;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._location = value;
                            this.element.translate(value.x, value.y);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Polygon.prototype.init = function () {
                        if(this.points.length === 0) {
                            return;
                        }
                        var points = Enumerable.From(Raphael2D.Utilities.Point2D.arrange(this.size, this.points)).Select(function (point, index) {
                            var result = "L " + point.x + "," + point.y;
                            if(index === 0) {
                                result = "M " + [
                                    point.x, 
                                    point.y
                                ].join(",") + result;
                            }
                            return result;
                        }).ToArray();
                        var path = points.join(" ");
                        if(this.isClosed) {
                            path += "Z";
                        }
                        this.element = (this.canvas).paper.path(path).translate(this.location.x, this.location.y);
                    };
                    return Polygon;
                })(Shape);
                Primitives.Polygon = Polygon;                
                var Rhombus = (function (_super) {
                    __extends(Rhombus, _super);
                    function Rhombus(canvas, location, size) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = new Drawings.Size(100, 100); }
                                        _super.call(this, canvas, [
                    {
                        x: 0,
                        y: 0,
                        verticalAlign: Drawings.VerticalAlign.top,
                        horizontalAlign: Drawings.HorizontalAlign.center,
                        isAbsolute: true
                    }, 
                    {
                        x: 0,
                        y: 0,
                        verticalAlign: Drawings.VerticalAlign.center,
                        horizontalAlign: Drawings.HorizontalAlign.right,
                        isAbsolute: true
                    }, 
                    {
                        x: 0,
                        y: 0,
                        verticalAlign: Drawings.VerticalAlign.bottom,
                        horizontalAlign: Drawings.HorizontalAlign.center,
                        isAbsolute: true
                    }, 
                    {
                        x: 0,
                        y: 0,
                        verticalAlign: Drawings.VerticalAlign.center,
                        horizontalAlign: Drawings.HorizontalAlign.left,
                        isAbsolute: true
                    }
                ], true, location, size);
                    }
                    return Rhombus;
                })(Polygon);
                Primitives.Rhombus = Rhombus;                
                var Arrow = (function (_super) {
                    __extends(Arrow, _super);
                    function Arrow(canvas, location, size) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = new Drawings.Size(100, 100); }
                                        _super.call(this, canvas, [
                    {
                        x: 0,
                        y: 0.3,
                        isAbsolute: false
                    }, 
                    {
                        x: 0.6,
                        y: 0.3,
                        isAbsolute: false
                    }, 
                    {
                        x: 0.6,
                        y: 0,
                        isAbsolute: false
                    }, 
                    {
                        x: 1,
                        y: 0.5,
                        isAbsolute: false
                    }, 
                    {
                        x: 0.6,
                        y: 1,
                        isAbsolute: false
                    }, 
                    {
                        x: 0.6,
                        y: 0.7,
                        isAbsolute: false
                    }, 
                    {
                        x: 0,
                        y: 0.7,
                        isAbsolute: false
                    }
                ], true, location, size);
                    }
                    return Arrow;
                })(Polygon);
                Primitives.Arrow = Arrow;                
                var Text = (function (_super) {
                    __extends(Text, _super);
                    function Text(canvas, text, location, fontSize, fontFamily, foreground, background) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof fontSize === "undefined") { fontSize = 10; }
                        if (typeof fontFamily === "undefined") { fontFamily = "Arial"; }
                        if (typeof foreground === "undefined") { foreground = Drawings.Colors.Black; }
                        if (typeof background === "undefined") { background = Drawings.Colors.Transparent; }
                                        _super.call(this, canvas, location, new Drawings.Size(0, 0));
                        this._text = text;
                        this._fontSize = fontSize;
                        this._fontFamily = fontFamily;
                        this._foreground = foreground;
                        this._background = background;
                        this.init();
                    }
                    Object.defineProperty(Text.prototype, "size", {
                        get: function () {
                            if(Ensure.isDefined(this.element)) {
                                var boundingBox = this.element.getBBox();
                                return new CodeCompass.Drawings.Size(boundingBox.width, boundingBox.height);
                            }
                            return CodeCompass.Drawings.Size.Zero;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Text.prototype, "text", {
                        get: function () {
                            return this._text;
                        },
                        set: function (value) {
                            Ensure.defined(this.element).defined(value);
                            this._text = value;
                            this.element.attr("text", value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Text.prototype, "fontSize", {
                        get: function () {
                            return this._fontSize;
                        },
                        set: function (value) {
                            Ensure.defined(value).defined(this.element);
                            this._fontSize = value;
                            this.element.attr({
                                "font-size": value
                            });
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Text.prototype, "fontFamily", {
                        get: function () {
                            return this._fontFamily;
                        },
                        set: function (value) {
                            Ensure.notBlank(value).defined(this.element);
                            this._fontFamily = value;
                            this.element.attr({
                                "font-family": value
                            });
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Text.prototype, "foreground", {
                        get: function () {
                            return this._foreground;
                        },
                        set: function (value) {
                            Ensure.defined(this.element).defined(value);
                            this._foreground = value;
                            this.element.attr({
                                "fill": value.toCSS()
                            });
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Text.prototype, "horizontalAlign", {
                        get: function () {
                            return this._horizontalAlign;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            var position;
                            switch(value) {
                                case Drawings.HorizontalAlign.left:
                                    position = "start";
                                    break;
                                case Drawings.HorizontalAlign.center:
                                    position = "middle";
                                    break;
                                case Drawings.HorizontalAlign.right:
                                    position = "end";
                                    break;
                            }
                            this.element.attr({
                                "text-anchor": position
                            });
                            this._horizontalAlign = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Text.prototype, "location", {
                        get: function () {
                            return this._location;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._location = new Drawings.Point2D(value.x, value.y);
                            Ensure.defined(this.element);
                            this.element.attr("x", value.x);
                            this.element.attr({
                                "y": value.y + this.fontSize / 2.0
                            });
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Text.prototype.init = function () {
                        this.element = (this.canvas).paper.text(this.location.x, this.location.y, this.text);
                        this.element.attr({
                            "font-family": this.fontFamily,
                            "font-size": this.fontSize,
                            "text-anchor": "start",
                            "fill": this.foreground.toCSS(),
                            "y": this.location.y + this.fontSize / 2.0
                        });
                        var boundingBox = this.element.getBBox();
                        this.size = new Drawings.Size(boundingBox.width, boundingBox.height);
                    };
                    return Text;
                })(GraphicalObject);
                Primitives.Text = Text;                
                var Group = (function (_super) {
                    __extends(Group, _super);
                    function Group(canvas, location, size) {
                        if (typeof location === "undefined") { location = Drawings.Point2D.Origo; }
                        if (typeof size === "undefined") { size = new CodeCompass.Drawings.Size(0, 0); }
                                        _super.call(this, canvas, location, size);
                        this.canvas = canvas;
                        this._isDisposed = false;
                        this._size = size;
                        this.init();
                    }
                    Object.defineProperty(Group.prototype, "isDisposed", {
                        get: function () {
                            return this._isDisposed;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Group.prototype, "size", {
                        get: function () {
                            return this._size;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._size = value;
                            this.update();
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Group.prototype, "visible", {
                        get: function () {
                            return this._visible;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._visible = value;
                            for(var child in this.children) {
                                this.children[child].visible = value;
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Group.prototype, "location", {
                        get: function () {
                            return this._location;
                        },
                        set: function (value) {
                            Ensure.defined(value);
                            this._location = value;
                            for(var child in this.children) {
                                var item = this.children[child];
                                var location = item.location;
                                Ensure.defined(location, "location");
                                item.location = location.add(value);
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Group.prototype, "children", {
                        get: function () {
                            return this._children;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Group.prototype.dispose = function () {
                        if(!this.isDisposed && Ensure.isDefined(this._children)) {
                            this._children.forEach(function (child) {
                                return child.dispose();
                            });
                            this._isDisposed = true;
                        }
                        return this;
                    };
                    Group.prototype.update = function (list) {
                        if (typeof list === "undefined") { list = this._children; }
                        var _this = this;
                        if(Ensure.isDefined(list)) {
                            list.forEach(function (child) {
                                child.location = Enumerable.From(Raphael2D.Utilities.Point2D.arrange(_this.size, [
                                    child.location
                                ])).First();
                                child.size = Enumerable.From(Raphael2D.Utilities.Size.arrange(_this.size, [
                                    child.size
                                ])).First();
                                if(Ensure.hasValue(child) && Ensure.hasValue(child.element)) {
                                    child.element.toFront();
                                }
                            });
                        }
                    };
                    Group.prototype.clear = function () {
                        return this;
                    };
                    Group.prototype.ungroup = function () {
                        var _this = this;
                        Let(this.location).be(function (value) {
                            var location = value;
                            _this.location = Drawings.Point2D.Origo;
                            _this._children = [];
                            _this._set.clear();
                            _this.location = location;
                        });
                        return this;
                    };
                    Group.prototype.add = function () {
                        var _this = this;
                        var children = [];
                        for (var _i = 0; _i < (arguments.length - 0); _i++) {
                            children[_i] = arguments[_i + 0];
                        }
                        Ensure.defined(children, "child: GraphicalObject (Group)");
                        children.forEach(function (value) {
                            _this._children.push(value);
                            _this._set.push(value.element);
                        });
                        this.update(children);
                        return this;
                    };
                    Group.prototype.init = function () {
                        this._children = [];
                        this._set = (this.canvas).paper.set();
                    };
                    return Group;
                })(GraphicalObject);
                Primitives.Group = Group;                
                var Line2D = (function (_super) {
                    __extends(Line2D, _super);
                    function Line2D(canvas, start, end) {
                                        _super.call(this, canvas, start, new Drawings.Size(Math.abs(end.add(start.negate()).x), Math.abs(end.add(start.negate()).y)));
                        this._start = start;
                        this._end = end;
                        this.init();
                    }
                    Object.defineProperty(Line2D.prototype, "arrowEnd", {
                        get: function () {
                            return this._arrowEnd;
                        },
                        set: function (value) {
                            Ensure.defined(value).defined(this.element, "this.element: RaphaelElement (Line2D)");
                            this._arrowEnd = value;
                            switch(value) {
                                case Drawings.ArrowEnd.block:
                                    this.element.attr("arrow-end", "block");
                                    break;
                                case Drawings.ArrowEnd.classic:
                                    this.element.attr("arrow-end", "classic");
                                    break;
                                case Drawings.ArrowEnd.diamond:
                                    this.element.attr("arrow-end", "diamond");
                                    break;
                                case Drawings.ArrowEnd.none:
                                    this.element.attr("arrow-end", "none");
                                    break;
                                case Drawings.ArrowEnd.open:
                                    this.element.attr("arrow-end", "open");
                                    break;
                                case Drawings.ArrowEnd.oval:
                                    this.element.attr("arrow-end", "oval");
                                    break;
                            }
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Line2D.prototype, "start", {
                        get: function () {
                            return this._start;
                        },
                        set: function (value) {
                            Ensure.defined(value).defined(this.element);
                            this._start = value;
                            this.location = value;
                            this.element.attr("path", Raphael2D.Utilities.Point2D.getPath(this.start, this.end));
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Line2D.prototype, "end", {
                        get: function () {
                            return this._end;
                        },
                        set: function (value) {
                            Ensure.defined(value).defined(this.element);
                            this._end = value;
                            this.element.attr("path", Raphael2D.Utilities.Point2D.getPath(this.start, this.end));
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Line2D.prototype, "stroke", {
                        get: function () {
                            return this._stroke;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Line2D.prototype.init = function () {
                        this.element = (this.canvas).paper.path(Raphael2D.Utilities.Point2D.getPath(this.start, this.end));
                        this._stroke = new Raphael2D.Stroke(this.element);
                        this.arrowEnd = Drawings.ArrowEnd.none;
                        this.element.attr("stroke-width", 4);
                    };
                    return Line2D;
                })(GraphicalObject);
                Primitives.Line2D = Line2D;                
                var MultiLine2D = (function (_super) {
                    __extends(MultiLine2D, _super);
                    function MultiLine2D(canvas, start, end) {
                        if (typeof start === "undefined") { start = Drawings.Point2D.Origo; }
                        if (typeof end === "undefined") { end = Drawings.Point2D.Origo; }
                                        _super.call(this, canvas, start, end);
                        this.start = start;
                        this.end = end;
                    }
                    MultiLine2D.prototype.getPoints = function () {
                        return Enumerable.From(this._points);
                    };
                    MultiLine2D.prototype.setPoints = function (value) {
                        Ensure.defined(value).defined(this.element);
                        this._points = value;
                        this.element.attr("path", Raphael2D.Utilities.Point2D.getPathFromArray(value));
                    };
                    return MultiLine2D;
                })(Line2D);
                Primitives.MultiLine2D = MultiLine2D;                
            })(Raphael2D.Primitives || (Raphael2D.Primitives = {}));
            var Primitives = Raphael2D.Primitives;
        })(Drawings.Raphael2D || (Drawings.Raphael2D = {}));
        var Raphael2D = Drawings.Raphael2D;
    })(CodeCompass.Drawings || (CodeCompass.Drawings = {}));
    var Drawings = CodeCompass.Drawings;
})(CodeCompass || (CodeCompass = {}));
//@ sourceMappingURL=DrawingsRaphael.js.map
