var Reflection;
(function (Reflection) {
    var Type = (function () {
        function Type(fullName, name) {
            if (typeof name === "undefined") { name = null; }
            Ensure.notBlank(fullName, "fullName");
            if(Ensure.isBlank(name)) {
                this._name = this.getShortName(fullName);
            } else {
                this._name = name;
            }
            this._fullName = fullName;
        }
        Object.defineProperty(Type.prototype, "name", {
            get: function () {
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Type.prototype, "fullName", {
            get: function () {
                return this._fullName;
            },
            enumerable: true,
            configurable: true
        });
        Type.prototype.getShortName = function (fullName) {
            return Enumerable.From(fullName.split(".")).Last();
        };
        Type.create = function create(fullName, name) {
            if (typeof name === "undefined") { name = null; }
            return new Type(fullName, name);
        };
        return Type;
    })();
    Reflection.Type = Type;    
})(Reflection || (Reflection = {}));
//@ sourceMappingURL=Reflection.js.map
